<template>
  <div>
    <v-progress-linear
      v-if="submitRequested"
      :indeterminate="true"
      height="4"
      color="success"
      background-color="lightSuccess"
      style="height: 4px;position: absolute;top: -16px;">
    </v-progress-linear>
    <div style="height: auto;max-height: 600px;overflow-y: auto;">
      <div v-if="showItemInformation"
        class="defaultCardBackground">
        <ul class="sellerDetailListItem" style="padding-top:0px;">
          <li>
            <span class="detailLabel">
              Item Name
            </span>
            &nbsp;&nbsp;{{fullItemInformationObject.name}}
          </li>
          <li>
            <span class="detailLabel">
              Number of items
            </span>
            &nbsp;&nbsp;{{itemInformation.numberOfItems}}
          </li>
          <li>
            <span class="detailLabel">
              Expected sales date
            </span>
            &nbsp;&nbsp;{{fullItemInformationObject.expectedSalesDate}}
          </li>
        </ul>
      </div>
      <div v-if="showBrandList">
        <v-list v-if="hideBrandAndStoreList"
          v-for="brandAndStore in brandAndStoreList"
          :key="brandAndStore.storeName">
          <div style="padding-left:20px;">
            {{brandAndStore.storeName}}
          </div>
          <v-divider></v-divider>
          <v-list v-for="brand in brandAndStore.brands"
            :key="brand"
            style="padding-left:40px;background:#f5f5f5">
            {{brand}}
          </v-list>
          <v-divider></v-divider>
        </v-list>
      </div>
      <div>
        <v-list v-for="shopList in fullItemInformationObject.itemInfo"
          :key="shopList.shopName"
          style="background:#d3e1e8;">
          <div style="padding-left:20px;">
            Branch: {{shopList.shopName}}
          </div>
          <v-divider></v-divider>
          <v-list v-for="bransAndSizeList in shopList.bransAndSize"
            :key="bransAndSizeList.brand"
            style="padding-left:40px;background:#f5f5f5">
            Brand: {{bransAndSizeList.brand}}
            <v-divider></v-divider>
            <v-list v-for="sizesList in bransAndSizeList.sizes"
              :key="sizesList.size"
              style="padding-left:40px;background:#f5f5f5;display: flex;justify-content: space-around;">
                <span>
                  Size: {{sizesList.size}}
                </span>
                <span>
                  Number: {{sizesList.number}}
                </span>
                <span>
                  Price: {{sizesList.price}}
                </span>
            </v-list>
          </v-list>
          <v-divider></v-divider>
        </v-list>
      </div>
      <div v-if="showRegisterItemButton">
        <br/>
        <v-btn depressed
          block
          color="darkSecondary"
          dark
          style="width:90%;margin:0 auto;margin-top:10px;"
          @click="onFinishItemRegistrationClick()">
          REGISTER ITEM
        </v-btn>
        <br/><br/>
      </div>
    </div>
  </div>
</template>
<script>
import axios from 'axios'
export default {
  name: 'BrandListComponent',
  data: () => ({
    submitRequested: false
  }),
  computed: {
    showItemInformation () {
      return this.$store.state.itemRegistrationModule.itemRegistrationFormValid
    },
    itemInformation () {
      return {
        itemName: this.$store.state.itemRegistrationModule.itemName,
        numberOfItems: this.$store.state.itemRegistrationModule.numberOfItems,
        expectedSalesDate: this.$store.state.itemRegistrationModule.expectedSalesDate
      }
    },
    showBrandList () {
      return this.$store.state.itemRegistrationModule.brandFormValid
    },
    brandAndStoreList () {
      return this.$store.state.itemRegistrationModule.storeList
    },
    sizeNumberPriceList () {
      return this.$store.state.itemRegistrationModule.sizePriceNumberList
    },
    hideBrandAndStoreList () {
      return this.$store.state.itemRegistrationModule.sizePriceNumberFormValid
    },
    showRegisterItemButton () {
      return this.$store.state.itemRegistrationModule.showRegisterItemButton
    },
    fullItemInformationObject () {
      return this.$store.state.itemRegistrationModule.fullItemInformationObject
    }
  },
  methods: {
    onFinishItemRegistrationClick () {
      let registrationRequestObject = {
        name: this.itemInformation.itemName,
        expectedSalesDate: this.itemInformation.expectedSalesDate + 'T01:01:00.000Z',
        itemInfo: this.sizeNumberPriceList
      }
      this.submitRequested = true
      axios.post('/item', registrationRequestObject)
        .then(response => {
          setTimeout(() => {
            this.submitRequested = false
            this.$router.push('/home/item_view/' + this.itemInformation.itemName)
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', this.itemInformation.itemName + ' item is succefully registered')
            this.$store.commit('UPDATE_ALL_ITEMS_LIST')
          }, 2000)
        })
        .catch(error => {
          this.submitRequested = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Item registration error: ' + error)
        })
    }
  }
}
</script>
